// PlayerManager.cpp : ʵļ
//

#include "stdafx.h"
#include "AjNetSdkDemo.h"
#include "AjNetSdkDemoDlg.h"
#include "PlayerManager.h"


// CPlayerManager

IMPLEMENT_DYNAMIC(CPlayerManager, CWnd)

CPlayerManager::CPlayerManager()
{
	for (int i = 0; i < MAX_CHANNEL; i++)
	{
		m_wndPlayer[i].wndPlayer = new CPlayerWnd(i);
	}
	m_iCurChannelNum = 4;
	m_iCurSelWndIndex = -1;
}

CPlayerManager::~CPlayerManager()
{
	for (int i = 0; i < MAX_CHANNEL; i++)
	{
		SAFE_DELETE(m_wndPlayer[i].wndPlayer);
	}
	DestroyWindow();
}

BEGIN_MESSAGE_MAP(CPlayerManager, CWnd)
	ON_WM_SIZE()
	ON_WM_CREATE()
	ON_MESSAGE(UM_PLAYWND_SELECT,&CPlayerManager::OnSelectPlayerWnd)
END_MESSAGE_MAP()

// CPlayerManager Ϣ
int CPlayerManager::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	for (int i = 0; i < MAX_CHANNEL; i++)
	{
		m_wndPlayer[i].wndPlayer->Create(
			NULL,
			NULL,
			WS_CHILD | WS_CLIPSIBLINGS | WS_CLIPCHILDREN,
			CRect(0, 0, 0, 0),
			this,
			NULL);
	}

	return 0;
}

void CPlayerManager::OnSize(UINT nType, int cx, int cy)
{
	CWnd::OnSize(nType, cx, cy);

	ReLayoutWnd();
}

//ƲŴ
int CPlayerManager::ReLayoutWnd()
{
	CRect rcClient;
	GetClientRect(rcClient);
	if (m_iCurChannelNum <= 0 || m_iCurChannelNum > MAX_CHANNEL || m_iCurChannelNum < 1)
		m_iCurChannelNum = 4;
	for (int iIndex = 0; iIndex < MAX_CHANNEL; iIndex++)
	{
		if (iIndex < m_iCurChannelNum)
		{
			CRect rcDraw = GetChlPosition(iIndex, rcClient);
			if (m_wndPlayer[iIndex].wndPlayer->GetSafeHwnd())
			{
				m_wndPlayer[iIndex].wndPlayer->SetWindowPos(NULL, rcDraw.left, rcDraw.top, rcDraw.Width(), rcDraw.Height(), SWP_SHOWWINDOW);
				m_wndPlayer[iIndex].rcWnd.CopyRect(rcDraw);
			}
			
		}
		else
		{
			if (m_wndPlayer[iIndex].wndPlayer && m_wndPlayer[iIndex].wndPlayer->GetSafeHwnd() && m_wndPlayer[iIndex].wndPlayer->IsWindowVisible())
				m_wndPlayer[iIndex].wndPlayer->ShowWindow(SW_HIDE);
		}
	}
	return 0;
}

CRect CPlayerManager::GetChlPosition(int nChannelNo, CRect rcClient)
{
	//m_iCurChannelNum;	//ʾ:4 6 8 9 10 13 16 22 25 27 33 36
	CRect rcDraw;
	int iRows = 0;
	int iCols = 0;
	bool bSqrt = false;
	int nSqrtValue = (int)sqrt((double)m_iCurChannelNum);
	if (nSqrtValue * nSqrtValue == m_iCurChannelNum)
	{
		iRows = iCols = nSqrtValue;
		bSqrt = true;
	}
	else
	{
		if (m_iCurChannelNum == 8)
			iRows = iCols = 4;
		else
			iRows = iCols = nSqrtValue + 1;
	}
	if (bSqrt)
	{
		int i = nChannelNo / iRows;
		int j = nChannelNo % iRows;
		return GetWindowRect(iRows, iCols, i, j, rcClient);
	}
	if (m_iCurChannelNum == 6)
	{
		if (nChannelNo == 0)
		{
			CRect rect0 = GetWindowRect(iRows, iCols, 0, 0, rcClient);
			CRect rect4 = GetWindowRect(iRows, iCols, 1, 1, rcClient);
			rcDraw = CRect(rect0.left, rect0.top, rect4.right, rect4.bottom);
		}
		else if (nChannelNo == 1)
		{
			int i = (nChannelNo + 1) / iRows;
			int j = (nChannelNo + 1) % iRows;
			rcDraw = GetWindowRect(iRows, iCols, i, j, rcClient);
		}
		else
		{
			int i = (nChannelNo + 3) / iRows;
			int j = (nChannelNo + 3) % iRows;
			rcDraw = GetWindowRect(iRows, iCols, i, j, rcClient);
		}
	}
	else if (m_iCurChannelNum == 8)
	{
		if (nChannelNo == 0)
		{
			CRect rect0 = GetWindowRect(iRows, iCols, 0, 0, rcClient);
			CRect rect10 = GetWindowRect(iRows, iCols, 2, 2, rcClient);
			rcDraw = CRect(rect0.left, rect0.top, rect10.right, rect10.bottom);
		}
		else if (nChannelNo == 1)
		{
			int i = (nChannelNo + 2) / iRows;
			int j = (nChannelNo + 2) % iRows;
			rcDraw = GetWindowRect(iRows, iCols, i, j, rcClient);
		}
		else if (nChannelNo == 2)
		{
			int i = (nChannelNo + 5) / iRows;
			int j = (nChannelNo + 5) % iRows;
			rcDraw = GetWindowRect(iRows, iCols, i, j, rcClient);
		}
		else
		{
			int i = (nChannelNo + 8) / iRows;
			int j = (nChannelNo + 8) % iRows;
			rcDraw = GetWindowRect(iRows, iCols, i, j, rcClient);
		}
	}
	else if (m_iCurChannelNum == 10)
	{
		if (nChannelNo == 8)
		{
			CRect rect8 = GetWindowRect(iRows, iCols, 2, 0, rcClient);
			CRect rect13 = GetWindowRect(iRows, iCols, 3, 1, rcClient);
			rcDraw = CRect(rect8.left, rect8.top, rect13.right, rect13.bottom);
		}
		else if (nChannelNo == 9)
		{
			CRect rect10 = GetWindowRect(iRows, iCols, 2, 2, rcClient);
			CRect rect15 = GetWindowRect(iRows, iCols, 3, 3, rcClient);
			rcDraw = CRect(rect10.left, rect10.top, rect15.right, rect15.bottom);
		}
		else
		{
			int i = (nChannelNo) / iRows;
			int j = (nChannelNo) % iRows;
			rcDraw = GetWindowRect(iRows, iCols, i, j, rcClient);
		}
	}
	else if (m_iCurChannelNum == 13)
	{
		if (nChannelNo <= 4)
		{
			int i = (nChannelNo) / iRows;
			int j = (nChannelNo) % iRows;
			rcDraw = GetWindowRect(iRows, iCols, i, j, rcClient);
		}
		else if (nChannelNo == 5)
		{
			CRect rect5 = GetWindowRect(iRows, iCols, 1, 1, rcClient);
			CRect rect10 = GetWindowRect(iRows, iCols, 2, 2, rcClient);
			rcDraw = CRect(rect5.left, rect5.top, rect10.right, rect10.bottom);
		}
		else if (nChannelNo >= 6 && nChannelNo <= 7)
		{
			int i = (nChannelNo + 1) / iRows;
			int j = (nChannelNo + 1) % iRows;
			rcDraw = GetWindowRect(iRows, iCols, i, j, rcClient);
		}
		else
		{
			int i = (nChannelNo + 3) / iRows;
			int j = (nChannelNo + 3) % iRows;
			rcDraw = GetWindowRect(iRows, iCols, i, j, rcClient);
		}
	}
	else if (m_iCurChannelNum == 17)
	{
		if (nChannelNo < 6)
		{
			int i = (nChannelNo) / iRows;
			int j = (nChannelNo) % iRows;
			rcDraw = GetWindowRect(iRows, iCols, i, j, rcClient);
		}
		else if (nChannelNo == 6)
		{
			CRect rect7 = GetWindowRect(iRows, iCols, 1, 1, rcClient);
			CRect rect18 = GetWindowRect(iRows, iCols, 3, 3, rcClient);
			rcDraw = CRect(rect7.left, rect7.top, rect18.right, rect18.bottom);
		}
		else if (nChannelNo >= 7 && nChannelNo <= 8)
		{
			int i = (nChannelNo + 2) / iRows;
			int j = (nChannelNo + 2) % iRows;
			rcDraw = GetWindowRect(iRows, iCols, i, j, rcClient);
		}
		else if (nChannelNo >= 9 && nChannelNo <= 10)
		{
			int i = (nChannelNo + 5) / iRows;
			int j = (nChannelNo + 5) % iRows;
			rcDraw = GetWindowRect(iRows, iCols, i, j, rcClient);
		}
		else
		{
			int i = (nChannelNo + 8) / iRows;
			int j = (nChannelNo + 8) % iRows;
			rcDraw = GetWindowRect(iRows, iCols, i, j, rcClient);
		}
	}
	else if (m_iCurChannelNum == 22)
	{
		if (nChannelNo == 0)
		{
			CRect rect0 = GetWindowRect(iRows, iCols, 0, 0, rcClient);
			CRect rect6 = GetWindowRect(iRows, iCols, 1, 1, rcClient);
			rcDraw = CRect(rect0.left, rect0.top, rect6.right, rect6.bottom);
		}

		else if (nChannelNo >= 1 && nChannelNo <= 3)
		{
			int i = (nChannelNo + 1) / iRows;
			int j = (nChannelNo + 1) % iRows;
			rcDraw = GetWindowRect(iRows, iCols, i, j, rcClient);
		}
		else
		{
			int i = (nChannelNo + 3) / iRows;
			int j = (nChannelNo + 3) % iRows;
			rcDraw = GetWindowRect(iRows, iCols, i, j, rcClient);
		}
	}
	else if (m_iCurChannelNum == 27)
	{
		if (nChannelNo <= 2)
		{
			CRect rect0 = GetWindowRect(iRows, iCols, 0, nChannelNo * 2, rcClient);
			CRect rect1 = GetWindowRect(iRows, iCols, 1, nChannelNo * 2 + 1, rcClient);
			rcDraw = CRect(rect0.left, rect0.top, rect1.right, rect1.bottom);
		}
		else
		{
			int i = (nChannelNo + 9) / iRows;
			int j = (nChannelNo + 9) % iRows;
			rcDraw = GetWindowRect(iRows, iCols, i, j, rcClient);
		}
	}
	else if (m_iCurChannelNum == 33)
	{
		if (nChannelNo < 14)
		{
			int i = (nChannelNo) / iRows;
			int j = (nChannelNo) % iRows;
			rcDraw = GetWindowRect(iRows, iCols, i, j, rcClient);
		}
		else if (nChannelNo == 14)
		{
			CRect rect14 = GetWindowRect(iRows, iCols, 2, 2, rcClient);
			CRect rect21 = GetWindowRect(iRows, iCols, 3, 3, rcClient);
			rcDraw = CRect(rect14.left, rect14.top, rect21.right, rect21.bottom);
		}
		else if (nChannelNo > 15 && nChannelNo <= 18)
		{
			int i = (nChannelNo + 1) / iRows;
			int j = (nChannelNo + 1) % iRows;
			rcDraw = GetWindowRect(iRows, iCols, i, j, rcClient);
		}
		else
		{
			int i = (nChannelNo + 3) / iRows;
			int j = (nChannelNo + 3) % iRows;
			rcDraw = GetWindowRect(iRows, iCols, i, j, rcClient);
		}
	}
	return rcDraw;
}

CRect CPlayerManager::GetWindowRect(int iRows, int iCols, int iRowNo, int iColNo, CRect rcClient)
{
	int i_W = max(0, rcClient.Width() / iRows);
	int i_H = max(0, rcClient.Height() / iCols);
	int iMW = rcClient.Width() % iCols;
	int iMH = rcClient.Height() % iRows;
	CRect rcDraw;
	if (iRowNo == iRows - 1 && iColNo == iCols - 1)
		rcDraw = CRect(iColNo*i_W, iRowNo*i_H, iColNo*i_W + i_W + iMW, iRowNo*i_H + i_H + iMH);
	else if (iRowNo == iRows - 1)
		rcDraw = CRect(iColNo*i_W, iRowNo*i_H, iColNo*i_W + i_W, iRowNo*i_H + i_H + iMH);
	else if (iColNo == iCols - 1)
		rcDraw = CRect(iColNo*i_W, iRowNo*i_H, iColNo*i_W + i_W + iMW, iRowNo*i_H + i_H);
	else
		rcDraw = CRect(iColNo*i_W, iRowNo*i_H, iColNo*i_W + i_W, iRowNo*i_H + i_H);
	return rcDraw;
}

//////////////////////////////////////////////////////////////////////////
//ѡвŴϢ
LRESULT CPlayerManager::OnSelectPlayerWnd(WPARAM wp, LPARAM lp)
{
	SetSelWnd(wp);
	((CAjNetSdkDemoDlg*)theApp.m_pMainWnd)->SelWndChange();
	return S_OK;
}
//ȡŴ
CPlayerWnd* CPlayerManager::GetPlayerWnd(unsigned int index)
{
	CPlayerWnd* wnd = NULL;
	if (index >= 0 && index < MAX_CHANNEL)
	{
		wnd = m_wndPlayer[index].wndPlayer;
	}
	return wnd;
}

int	CPlayerManager::SetSelWnd(int index)
{
	if (index >= 0 && index < MAX_CHANNEL)
	{
		if (m_iCurSelWndIndex >= 0)
			m_wndPlayer[m_iCurSelWndIndex].wndPlayer->SetWndFocus(FALSE);
		m_wndPlayer[index].wndPlayer->SetWndFocus(TRUE);
		m_iCurSelWndIndex = index;
	}
	return 0;
}

int CPlayerManager::GetSelWnd()
{
	return m_iCurSelWndIndex;
}

int CPlayerManager::SetCurWndNum(unsigned int iWndNum)
{
	if (m_iCurChannelNum == iWndNum)
		return -1;
	if (iWndNum >= 0 && iWndNum <= MAX_CHANNEL)
	{
		m_iCurChannelNum = iWndNum;
		ReLayoutWnd();
	}
	return 0;
}

int CPlayerManager::GetCurWndNum()
{
	return m_iCurChannelNum;
}

int CPlayerManager::GetFreeWnd()
{
	int index = -1;
	for (int i = 0; i < m_iCurChannelNum;i++)
	{
		if (m_wndPlayer[i].wndPlayer->GetDevice() == NULL)
		{
			index = i;
			break;
		}
	}
	if (index == -1)
	{
		if (m_iCurSelWndIndex >= 0 && m_iCurSelWndIndex < m_iCurChannelNum)
		{
			index = m_iCurSelWndIndex;
		}
	}
	if (index == -1)
	{
		index = 0;
	}
	return index;
}